/*****************************************************************************/
/* 1bpp.c                                                                    */
/* Sample 1 BitPlane Decoder Module                                          */
/* (c) 2000 Jay                                                              */
/*****************************************************************************/
#include "dm.h"

void startup()
{
   export.help = SystemHelp;
}

int tile_pack(unsigned char *dest,const unsigned char *src,int width,int height)
{
   int i;

   for(i = 0; i < height; i++) {
      dest[i] = ((src[0] & 1) << 7) | ((src[1] & 1) << 6) | ((src[2] & 1) << 5) | ((src[3] & 1) << 4) |
                ((src[4] & 1) << 3) | ((src[5] & 1) << 2) | ((src[6] & 1) << 1) | ((src[7] & 1));
      src += 8;
   }
   return width*height;
}

int tile_unpack(unsigned char *dest,const unsigned char *src,int width,int height)
{
   int i, j, pix;

   for(i = 0; i < height; i++) {
      pix = src[i];
      for(j = 0; j < 8; j++) {
         dest[j] = (pix >> 7) & 1;
         pix <<= 1;
      }
      dest += 8;
   }
   return height*width/8;
}

/* you must define an EXPORTSTRUC with 'export' in order to export data */
static EXPORTSTRUC export =
{
/*entry*/         startup,
/*tile_pack*/     tile_pack,
/*tile_unpack*/   tile_unpack,
/*update*/        NULL,
/*save*/          NULL,
/*minwidth*/      8,
/*minheight*/     1,
/*maxwidth*/      8,
/*maxheight*/     16,
/*bpp*/           1,
/*maxpal*/        2,
/*modestr*/       "1 BPP",
/*help*/          NULL,
/*key*/           { 0, 0, 0, 0 },
/*KeyHandler*/    { NULL, NULL, NULL, NULL }
};